#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 4;

int main() {

    size_t number_count;
    cerr << "Enter number count: ";
    cin >> number_count;

    vector<double> numbers(number_count);
    cerr << "Enter massive elements: ";
    for (size_t i = 0; i < number_count; i++) {
        cin >> numbers[i];
    }

    size_t bin_count;
    cerr << "Enter bin count: ";
    cin >> bin_count;

    vector<size_t> bins(bin_count);

    double mini = numbers[0];
    double maxi = numbers[0];
    for (double x : numbers) {
        if (x < mini) {
            mini = x;
        }
        else if (x > maxi) {
            maxi = x;
        }
    }

    double bin_size = (maxi - mini) / bin_count;
    for (size_t i = 0; i < number_count; i++) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++){
            auto lo = mini + j * bin_size;
            auto hi = mini + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
        }
    }



   size_t max_count = bins[0];
        for (size_t i = 0; i < bin_count; i++) {
            if (bins[i]>max_count) {
             max_count = bins[i];
            }
        }

    vector<size_t> height(bin_count);
    for (size_t i = 0; i < bin_count; i++) {
        if (max_count > MAX_ASTERISK) {
            height[i] = round(MAX_ASTERISK * (static_cast<double>(bins[i]) / max_count));
        } else {
            height[i]=bins[i];
        }
    }

    for (size_t i = 0; i < bin_count; i++) {
            if (bins[i] < 10) {
              cout << "  ";
            } else if (bins[i] < 100) {
                cout << " ";
            }
        cout << bins[i] << "| ";


        for (size_t j = 0; j<height[i]; j++) {
            cout <<" * ";
        }
        cout << endl;
    }
}

